" Vim syntax file

if exists("b:current_syntax")
  finish
endif

"Keywords
syn keyword quantifiers Π Σ Pi Sig Fty LΠ LPi W Forall Exists
syn match quantifiers "∀"
syn match quantifiers "∃"
syn keyword binders λ fun let in #
syn match binders  "="
syn match   tyconstructors "U\d*"
syn match   tyconstructors "L\d*"
syn match   tyconstructors "->"
syn match   tyconstructors "+"
syn match   tyconstructors "-o"
syn match   tyconstructors "&"
syn match   tyconstructors "*"
syn match   tyconstructors "⊗"
syn match   tyconstructors "|->"
syn match   tyconstructors "ℕ"
syn match   tyconstructors "⊥"
syn match   tyconstructors "|"
syn keyword tyconstructors T Comp Nat Eq Unit I Bot Loc
syn match   constructors "()"
syn keyword constructors Pack pack value G F S sup refl
syn match eliminators  "π₁"
syn match eliminators  "π₂"
syn keyword eliminators fst snd run IndNat NatInd IndW IndPlus IndUnit J value IndBot
syn keyword eliminators new get set free
syn match eliminators "Ind+"
syn match eliminators "Ind⊥"
syn keyword commands val compute check import include axiom interpret generalize
syn match keychar ":"
syn match commands ":="
syn match keychar "\."
syn match keychar "," 
syn match keychar "!" 
syn region comments start="(\*" end="\*)" 


let b:current_syntax = "dln"

hi def link quantifiers Type
hi def link tyconstructors Constant
hi def link constructors Constant
hi def link eliminators Constant
hi def link binders Statement
hi def link commands Include
hi def link comments Comment
hi def link keychar Special
